#line 1 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date_parser.rl"

#line 9 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date_parser.rl"


#include "smtp_parsers.h"
#include "util.h"


#line 11 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
static const int smtp_date_parser_start = 1;
static const int smtp_date_parser_first_final = 78;
static const int smtp_date_parser_error = 0;

static const int smtp_date_parser_en_balanced_ccontent = 77;
static const int smtp_date_parser_en_main = 1;


#line 14 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date_parser.rl"


guint64
rspamd_parse_smtp_date (const unsigned char *data, size_t len, GError **err)
{
	const unsigned char *p = data, *pe = data + len, *eof = data + len, *tmp = data;
	struct tm tm;
	glong tz = 0;
	gint cs = 0, *stack = NULL;;
	gsize top = 0;
	
	memset (&tm, 0, sizeof (tm));
	
	struct _ragel_st_storage {
		int *data;
		gsize size;
	} st_storage;
	memset (&st_storage, 0, sizeof (st_storage));
	
	
#line 41 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
	{
		cs = (int)smtp_date_parser_start;
		top = 0;
	}
	
#line 33 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date_parser.rl"
	
	
#line 50 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
	{
		if ( p == pe )
			goto _test_eof;
		goto _resume;
		
		_again: {}
		switch ( cs ) {
			case 1: goto _st1;
			case 0: goto _st0;
			case 2: goto _st2;
			case 3: goto _st3;
			case 4: goto _st4;
			case 5: goto _st5;
			case 6: goto _st6;
			case 7: goto _st7;
			case 8: goto _st8;
			case 9: goto _st9;
			case 10: goto _st10;
			case 11: goto _st11;
			case 12: goto _st12;
			case 13: goto _st13;
			case 14: goto _st14;
			case 15: goto _st15;
			case 16: goto _st16;
			case 17: goto _st17;
			case 18: goto _st18;
			case 19: goto _st19;
			case 20: goto _st20;
			case 78: goto _st78;
			case 79: goto _st79;
			case 21: goto _st21;
			case 80: goto _st80;
			case 81: goto _st81;
			case 22: goto _st22;
			case 82: goto _st82;
			case 23: goto _st23;
			case 83: goto _st83;
			case 84: goto _st84;
			case 24: goto _st24;
			case 85: goto _st85;
			case 25: goto _st25;
			case 86: goto _st86;
			case 87: goto _st87;
			case 26: goto _st26;
			case 88: goto _st88;
			case 89: goto _st89;
			case 27: goto _st27;
			case 90: goto _st90;
			case 28: goto _st28;
			case 91: goto _st91;
			case 92: goto _st92;
			case 29: goto _st29;
			case 93: goto _st93;
			case 30: goto _st30;
			case 94: goto _st94;
			case 95: goto _st95;
			case 96: goto _st96;
			case 31: goto _st31;
			case 32: goto _st32;
			case 33: goto _st33;
			case 34: goto _st34;
			case 35: goto _st35;
			case 36: goto _st36;
			case 37: goto _st37;
			case 38: goto _st38;
			case 39: goto _st39;
			case 40: goto _st40;
			case 41: goto _st41;
			case 42: goto _st42;
			case 43: goto _st43;
			case 44: goto _st44;
			case 45: goto _st45;
			case 46: goto _st46;
			case 47: goto _st47;
			case 48: goto _st48;
			case 49: goto _st49;
			case 50: goto _st50;
			case 51: goto _st51;
			case 52: goto _st52;
			case 53: goto _st53;
			case 54: goto _st54;
			case 55: goto _st55;
			case 56: goto _st56;
			case 57: goto _st57;
			case 58: goto _st58;
			case 59: goto _st59;
			case 60: goto _st60;
			case 61: goto _st61;
			case 62: goto _st62;
			case 63: goto _st63;
			case 64: goto _st64;
			case 65: goto _st65;
			case 66: goto _st66;
			case 67: goto _st67;
			case 68: goto _st68;
			case 69: goto _st69;
			case 70: goto _st70;
			case 71: goto _st71;
			case 72: goto _st72;
			case 73: goto _st73;
			case 74: goto _st74;
			case 75: goto _st75;
			case 76: goto _st76;
			case 77: goto _st77;
			case 97: goto _st97;
		}
		
		_resume: {}
		switch ( cs ) {
			case 1:
			goto st_case_1;
			case 0:
			goto st_case_0;
			case 2:
			goto st_case_2;
			case 3:
			goto st_case_3;
			case 4:
			goto st_case_4;
			case 5:
			goto st_case_5;
			case 6:
			goto st_case_6;
			case 7:
			goto st_case_7;
			case 8:
			goto st_case_8;
			case 9:
			goto st_case_9;
			case 10:
			goto st_case_10;
			case 11:
			goto st_case_11;
			case 12:
			goto st_case_12;
			case 13:
			goto st_case_13;
			case 14:
			goto st_case_14;
			case 15:
			goto st_case_15;
			case 16:
			goto st_case_16;
			case 17:
			goto st_case_17;
			case 18:
			goto st_case_18;
			case 19:
			goto st_case_19;
			case 20:
			goto st_case_20;
			case 78:
			goto st_case_78;
			case 79:
			goto st_case_79;
			case 21:
			goto st_case_21;
			case 80:
			goto st_case_80;
			case 81:
			goto st_case_81;
			case 22:
			goto st_case_22;
			case 82:
			goto st_case_82;
			case 23:
			goto st_case_23;
			case 83:
			goto st_case_83;
			case 84:
			goto st_case_84;
			case 24:
			goto st_case_24;
			case 85:
			goto st_case_85;
			case 25:
			goto st_case_25;
			case 86:
			goto st_case_86;
			case 87:
			goto st_case_87;
			case 26:
			goto st_case_26;
			case 88:
			goto st_case_88;
			case 89:
			goto st_case_89;
			case 27:
			goto st_case_27;
			case 90:
			goto st_case_90;
			case 28:
			goto st_case_28;
			case 91:
			goto st_case_91;
			case 92:
			goto st_case_92;
			case 29:
			goto st_case_29;
			case 93:
			goto st_case_93;
			case 30:
			goto st_case_30;
			case 94:
			goto st_case_94;
			case 95:
			goto st_case_95;
			case 96:
			goto st_case_96;
			case 31:
			goto st_case_31;
			case 32:
			goto st_case_32;
			case 33:
			goto st_case_33;
			case 34:
			goto st_case_34;
			case 35:
			goto st_case_35;
			case 36:
			goto st_case_36;
			case 37:
			goto st_case_37;
			case 38:
			goto st_case_38;
			case 39:
			goto st_case_39;
			case 40:
			goto st_case_40;
			case 41:
			goto st_case_41;
			case 42:
			goto st_case_42;
			case 43:
			goto st_case_43;
			case 44:
			goto st_case_44;
			case 45:
			goto st_case_45;
			case 46:
			goto st_case_46;
			case 47:
			goto st_case_47;
			case 48:
			goto st_case_48;
			case 49:
			goto st_case_49;
			case 50:
			goto st_case_50;
			case 51:
			goto st_case_51;
			case 52:
			goto st_case_52;
			case 53:
			goto st_case_53;
			case 54:
			goto st_case_54;
			case 55:
			goto st_case_55;
			case 56:
			goto st_case_56;
			case 57:
			goto st_case_57;
			case 58:
			goto st_case_58;
			case 59:
			goto st_case_59;
			case 60:
			goto st_case_60;
			case 61:
			goto st_case_61;
			case 62:
			goto st_case_62;
			case 63:
			goto st_case_63;
			case 64:
			goto st_case_64;
			case 65:
			goto st_case_65;
			case 66:
			goto st_case_66;
			case 67:
			goto st_case_67;
			case 68:
			goto st_case_68;
			case 69:
			goto st_case_69;
			case 70:
			goto st_case_70;
			case 71:
			goto st_case_71;
			case 72:
			goto st_case_72;
			case 73:
			goto st_case_73;
			case 74:
			goto st_case_74;
			case 75:
			goto st_case_75;
			case 76:
			goto st_case_76;
			case 77:
			goto st_case_77;
			case 97:
			goto st_case_97;
		}
		goto st_out;
		_st1:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof1;
		st_case_1:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _st1;
			}
			case 70u: {
				goto _st64;
			}
			case 77u: {
				goto _st68;
			}
			case 83u: {
				goto _st70;
			}
			case 84u: {
				goto _st72;
			}
			case 87u: {
				goto _st75;
			}
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr2;
		}
		{
			goto _st0;
		}
		st_case_0:
		_st0:
		cs = 0;
		goto _pop;
		_ctr2:
		{
#line 8 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
#line 406 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st2;
		_st2:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof2;
		st_case_2:
		if ( ( (*( p))) == 32u ) {
			goto _ctr9;
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st63;
		}
		{
			goto _st0;
		}
		_ctr9:
		{
#line 11 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n > 0 && n <= 31) {
						tm.tm_mday = n;
					}
					else {
						{p+= 1; cs = 3; goto _out;}
					}
				}
			}
		}
		
#line 446 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st3;
		_st3:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof3;
		st_case_3:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _st3;
			}
			case 65u: {
				goto _st4;
			}
			case 68u: {
				goto _st38;
			}
			case 70u: {
				goto _st41;
			}
			case 74u: {
				goto _st44;
			}
			case 77u: {
				goto _st50;
			}
			case 78u: {
				goto _st54;
			}
			case 79u: {
				goto _st57;
			}
			case 83u: {
				goto _st60;
			}
		}
		{
			goto _st0;
		}
		_st4:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof4;
		st_case_4:
		switch( ( (*( p))) ) {
			case 112u: {
				goto _st5;
			}
			case 117u: {
				goto _st36;
			}
		}
		{
			goto _st0;
		}
		_st5:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof5;
		st_case_5:
		if ( ( (*( p))) == 114u ) {
			goto _st6;
		}
		{
			goto _st0;
		}
		_st6:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof6;
		st_case_6:
		if ( ( (*( p))) == 32u ) {
			goto _ctr23;
		}
		{
			goto _st0;
		}
		_ctr23:
		{
#line 136 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 3;
		}
		
#line 555 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 563 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr83:
		{
#line 148 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 7;
		}
		
#line 573 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 581 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr86:
		{
#line 160 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 11;
		}
		
#line 591 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 599 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr89:
		{
#line 130 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 1;
		}
		
#line 609 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 617 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr93:
		{
#line 127 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 0;
		}
		
#line 627 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 635 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr96:
		{
#line 145 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 6;
		}
		
#line 645 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 653 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr97:
		{
#line 142 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 5;
		}
		
#line 663 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 671 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr101:
		{
#line 133 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 2;
		}
		
#line 681 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 689 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr102:
		{
#line 139 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 4;
		}
		
#line 699 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 707 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr105:
		{
#line 157 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 10;
		}
		
#line 717 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 725 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr108:
		{
#line 154 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 9;
		}
		
#line 735 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 743 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_ctr111:
		{
#line 151 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tm.tm_mon = 8;
		}
		
#line 753 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 24 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 761 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st7;
		_st7:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof7;
		st_case_7:
		if ( ( (*( p))) == 32u ) {
			goto _st7;
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr25;
		}
		{
			goto _st0;
		}
		_ctr25:
		{
#line 27 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
#line 791 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st8;
		_st8:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof8;
		st_case_8:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st9;
		}
		{
			goto _st0;
		}
		_st9:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof9;
		st_case_9:
		if ( ( (*( p))) == 32u ) {
			goto _ctr28;
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st34;
		}
		{
			goto _st0;
		}
		_ctr28:
		{
#line 30 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 1000) {
						if (n < 50) {
							tm.tm_year = n - 1900 + 2000;
						}
						else {
							tm.tm_year = n;
						}
					}
					else {
						tm.tm_year = n - 1900;
					}
				}
			}
		}
		
#line 853 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st10;
		_st10:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof10;
		st_case_10:
		if ( ( (*( p))) == 32u ) {
			goto _st10;
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr31;
		}
		{
			goto _st0;
		}
		_ctr31:
		{
#line 48 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
#line 883 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st11;
		_st11:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof11;
		st_case_11:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st12;
		}
		{
			goto _st0;
		}
		_st12:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof12;
		st_case_12:
		if ( ( (*( p))) == 58u ) {
			goto _ctr34;
		}
		{
			goto _st0;
		}
		_ctr34:
		{
#line 51 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 24) {
						tm.tm_hour = n;
					}
					else {
						{p+= 1; cs = 13; goto _out;}
					}
				}
			}
			else {
				{p+= 1; cs = 13; goto _out;}
			}
		}
		
#line 940 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st13;
		_st13:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof13;
		st_case_13:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr36;
		}
		{
			goto _st0;
		}
		_ctr36:
		{
#line 67 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
#line 967 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st14;
		_st14:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof14;
		st_case_14:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st15;
		}
		{
			goto _st0;
		}
		_st15:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof15;
		st_case_15:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr39;
			}
			case 58u: {
				goto _ctr40;
			}
		}
		{
			goto _st0;
		}
		_ctr39:
		{
#line 70 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
					else {
						{p+= 1; cs = 16; goto _out;}
					}
				}
			}
			else {
				{p+= 1; cs = 16; goto _out;}
			}
		}
		
#line 1029 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 122 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1036 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st16;
		_ctr80:
		{
#line 89 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n <= 60) { /* Leap second */
						tm.tm_sec = n;
					}
					else {
						{p+= 1; cs = 16; goto _out;}
					}
				}
			}
			else {
				{p+= 1; cs = 16; goto _out;}
			}
		}
		
#line 1059 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 122 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1066 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st16;
		_st16:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof16;
		st_case_16:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _st16;
			}
			case 43u: {
				goto _st17;
			}
			case 45u: {
				goto _st17;
			}
			case 67u: {
				goto _st81;
			}
			case 69u: {
				goto _st84;
			}
			case 71u: {
				goto _st87;
			}
			case 77u: {
				goto _st89;
			}
			case 80u: {
				goto _st92;
			}
			case 85u: {
				goto _st95;
			}
		}
		if ( ( (*( p))) < 75u ) {
			if ( 65u <= ( (*( p))) && ( (*( p))) <= 73u ) {
				goto _st80;
			}
		} else if ( ( (*( p))) > 90u ) {
			if ( ( (*( p))) > 105u ) {
				if ( 107u <= ( (*( p))) && ( (*( p))) <= 122u ) {
					goto _st80;
				}
			} else if ( ( (*( p))) >= 97u ) {
				goto _st80;
			}
		} else {
			goto _st80;
		}
		{
			goto _st0;
		}
		_st17:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof17;
		st_case_17:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr50;
		}
		{
			goto _st0;
		}
		_ctr50:
		{
#line 105 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
#line 1151 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 108 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			
		}
		
#line 1159 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st18;
		_st18:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof18;
		st_case_18:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st19;
		}
		{
			goto _st0;
		}
		_st19:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof19;
		st_case_19:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st20;
		}
		{
			goto _st0;
		}
		_st20:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof20;
		st_case_20:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st78;
		}
		{
			goto _st0;
		}
		_ctr123:
		{
#line 111 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);
				
				if (*(tmp - 1) == '-') {
					tz = -(tz);
				}
			}
		}
		
#line 1226 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st78;
		_st78:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof78;
		st_case_78:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr124;
			}
			case 40u: {
				goto _ctr125;
			}
		}
		{
			goto _st0;
		}
		_ctr124:
		{
#line 111 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);
				
				if (*(tmp - 1) == '-') {
					tz = -(tz);
				}
			}
		}
		
#line 1264 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr127:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1273 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr131:
		{
#line 179 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		
#line 1283 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1290 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr134:
		{
#line 176 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		
#line 1300 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1307 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr138:
		{
#line 173 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -400;
		}
		
#line 1317 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1324 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr141:
		{
#line 170 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		
#line 1334 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1341 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr145:
		{
#line 167 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		
#line 1351 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1358 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr149:
		{
#line 185 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		
#line 1368 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1375 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr152:
		{
#line 182 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		
#line 1385 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1392 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr156:
		{
#line 191 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		
#line 1402 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1409 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr159:
		{
#line 188 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -800;
		}
		
#line 1419 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1426 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_ctr164:
		{
#line 164 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		
#line 1436 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1443 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st79;
		_st79:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof79;
		st_case_79:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _st79;
			}
			case 40u: {
				goto _st21;
			}
		}
		{
			goto _st0;
		}
		_ctr56:
		{
#line 202 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			{{
#line 194 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 21; top+= 1; goto _st77;}}
		
#line 1483 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr125:
		{
#line 111 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				rspamd_strtoul (tmp, p - tmp, (gulong *)&tz);
				
				if (*(tmp - 1) == '-') {
					tz = -(tz);
				}
			}
		}
		
#line 1499 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr128:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1508 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr132:
		{
#line 179 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		
#line 1518 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1525 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr135:
		{
#line 176 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		
#line 1535 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1542 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr139:
		{
#line 173 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -400;
		}
		
#line 1552 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1559 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr142:
		{
#line 170 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		
#line 1569 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1576 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr146:
		{
#line 167 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		
#line 1586 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1593 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr150:
		{
#line 185 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		
#line 1603 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1610 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr153:
		{
#line 182 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		
#line 1620 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1627 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr157:
		{
#line 191 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		
#line 1637 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1644 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr160:
		{
#line 188 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -800;
		}
		
#line 1654 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1661 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_ctr165:
		{
#line 164 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		
#line 1671 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1678 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st21;
		_st21:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof21;
		st_case_21:
		switch( ( (*( p))) ) {
			case 40u: {
				goto _ctr56;
			}
			case 41u: {
				goto _st79;
			}
		}
		if ( ( (*( p))) > 91u ) {
			if ( 93u <= ( (*( p))) && ( (*( p))) <= 126u ) {
				goto _st21;
			}
		} else if ( ( (*( p))) >= 32u ) {
			goto _st21;
		}
		{
			goto _st0;
		}
		_ctr126:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1716 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st80;
		_st80:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof80;
		st_case_80:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
		}
		{
			goto _st0;
		}
		_ctr129:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1747 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st81;
		_st81:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof81;
		st_case_81:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
			case 68u: {
				goto _st22;
			}
			case 83u: {
				goto _st23;
			}
		}
		{
			goto _st0;
		}
		_st22:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof22;
		st_case_22:
		if ( ( (*( p))) == 84u ) {
			goto _st82;
		}
		{
			goto _st0;
		}
		_ctr130:
		{
#line 179 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		
#line 1802 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1809 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st82;
		_st82:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof82;
		st_case_82:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr131;
			}
			case 40u: {
				goto _ctr132;
			}
		}
		{
			goto _st0;
		}
		_st23:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof23;
		st_case_23:
		if ( ( (*( p))) == 84u ) {
			goto _st83;
		}
		{
			goto _st0;
		}
		_ctr133:
		{
#line 176 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		
#line 1858 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1865 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st83;
		_st83:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof83;
		st_case_83:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr134;
			}
			case 40u: {
				goto _ctr135;
			}
		}
		{
			goto _st0;
		}
		_ctr136:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1896 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st84;
		_st84:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof84;
		st_case_84:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
			case 68u: {
				goto _st24;
			}
			case 83u: {
				goto _st25;
			}
		}
		{
			goto _st0;
		}
		_st24:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof24;
		st_case_24:
		if ( ( (*( p))) == 84u ) {
			goto _st85;
		}
		{
			goto _st0;
		}
		_ctr137:
		{
#line 173 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -400;
		}
		
#line 1951 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 1958 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st85;
		_st85:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof85;
		st_case_85:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr138;
			}
			case 40u: {
				goto _ctr139;
			}
		}
		{
			goto _st0;
		}
		_st25:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof25;
		st_case_25:
		if ( ( (*( p))) == 84u ) {
			goto _st86;
		}
		{
			goto _st0;
		}
		_ctr140:
		{
#line 170 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -500;
		}
		
#line 2007 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2014 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st86;
		_st86:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof86;
		st_case_86:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr141;
			}
			case 40u: {
				goto _ctr142;
			}
		}
		{
			goto _st0;
		}
		_ctr143:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2045 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st87;
		_st87:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof87;
		st_case_87:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
			case 77u: {
				goto _st26;
			}
		}
		{
			goto _st0;
		}
		_st26:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof26;
		st_case_26:
		if ( ( (*( p))) == 84u ) {
			goto _st88;
		}
		{
			goto _st0;
		}
		_ctr144:
		{
#line 167 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		
#line 2097 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2104 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st88;
		_st88:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof88;
		st_case_88:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr145;
			}
			case 40u: {
				goto _ctr146;
			}
		}
		{
			goto _st0;
		}
		_ctr147:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2135 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st89;
		_st89:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof89;
		st_case_89:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
			case 68u: {
				goto _st27;
			}
			case 83u: {
				goto _st28;
			}
		}
		{
			goto _st0;
		}
		_st27:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof27;
		st_case_27:
		if ( ( (*( p))) == 84u ) {
			goto _st90;
		}
		{
			goto _st0;
		}
		_ctr148:
		{
#line 185 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -600;
		}
		
#line 2190 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2197 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st90;
		_st90:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof90;
		st_case_90:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr149;
			}
			case 40u: {
				goto _ctr150;
			}
		}
		{
			goto _st0;
		}
		_st28:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof28;
		st_case_28:
		if ( ( (*( p))) == 84u ) {
			goto _st91;
		}
		{
			goto _st0;
		}
		_ctr151:
		{
#line 182 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		
#line 2246 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2253 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st91;
		_st91:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof91;
		st_case_91:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr152;
			}
			case 40u: {
				goto _ctr153;
			}
		}
		{
			goto _st0;
		}
		_ctr154:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2284 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st92;
		_st92:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof92;
		st_case_92:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
			case 68u: {
				goto _st29;
			}
			case 83u: {
				goto _st30;
			}
		}
		{
			goto _st0;
		}
		_st29:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof29;
		st_case_29:
		if ( ( (*( p))) == 84u ) {
			goto _st93;
		}
		{
			goto _st0;
		}
		_ctr155:
		{
#line 191 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -700;
		}
		
#line 2339 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2346 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st93;
		_st93:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof93;
		st_case_93:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr156;
			}
			case 40u: {
				goto _ctr157;
			}
		}
		{
			goto _st0;
		}
		_st30:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof30;
		st_case_30:
		if ( ( (*( p))) == 84u ) {
			goto _st94;
		}
		{
			goto _st0;
		}
		_ctr158:
		{
#line 188 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = -800;
		}
		
#line 2395 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2402 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st94;
		_st94:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof94;
		st_case_94:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr159;
			}
			case 40u: {
				goto _ctr160;
			}
		}
		{
			goto _st0;
		}
		_ctr161:
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2433 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st95;
		_st95:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof95;
		st_case_95:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr127;
			}
			case 40u: {
				goto _ctr128;
			}
			case 84u: {
				goto _st96;
			}
		}
		{
			goto _st0;
		}
		_ctr163:
		{
#line 164 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tz = 0;
		}
		
#line 2468 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		{
#line 120 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
		}
		
#line 2475 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st96;
		_st96:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof96;
		st_case_96:
		switch( ( (*( p))) ) {
			case 32u: {
				goto _ctr164;
			}
			case 40u: {
				goto _ctr165;
			}
		}
		{
			goto _st0;
		}
		_ctr40:
		{
#line 70 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			if (p > tmp) {
				gulong n;
				if (rspamd_strtoul (tmp, p - tmp, &n)) {
					if (n < 60) {
						tm.tm_min = n;
					}
					else {
						{p+= 1; cs = 31; goto _out;}
					}
				}
			}
			else {
				{p+= 1; cs = 31; goto _out;}
			}
		}
		
#line 2520 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st31;
		_st31:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof31;
		st_case_31:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr77;
		}
		{
			goto _st0;
		}
		_ctr77:
		{
#line 86 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			
			tmp = p;
		}
		
#line 2547 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st32;
		_st32:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof32;
		st_case_32:
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st33;
		}
		{
			goto _st0;
		}
		_st33:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof33;
		st_case_33:
		if ( ( (*( p))) == 32u ) {
			goto _ctr80;
		}
		{
			goto _st0;
		}
		_st34:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof34;
		st_case_34:
		if ( ( (*( p))) == 32u ) {
			goto _ctr28;
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _st35;
		}
		{
			goto _st0;
		}
		_st35:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof35;
		st_case_35:
		if ( ( (*( p))) == 32u ) {
			goto _ctr28;
		}
		{
			goto _st0;
		}
		_st36:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof36;
		st_case_36:
		if ( ( (*( p))) == 103u ) {
			goto _st37;
		}
		{
			goto _st0;
		}
		_st37:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof37;
		st_case_37:
		if ( ( (*( p))) == 32u ) {
			goto _ctr83;
		}
		{
			goto _st0;
		}
		_st38:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof38;
		st_case_38:
		if ( ( (*( p))) == 101u ) {
			goto _st39;
		}
		{
			goto _st0;
		}
		_st39:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof39;
		st_case_39:
		if ( ( (*( p))) == 99u ) {
			goto _st40;
		}
		{
			goto _st0;
		}
		_st40:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof40;
		st_case_40:
		if ( ( (*( p))) == 32u ) {
			goto _ctr86;
		}
		{
			goto _st0;
		}
		_st41:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof41;
		st_case_41:
		if ( ( (*( p))) == 101u ) {
			goto _st42;
		}
		{
			goto _st0;
		}
		_st42:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof42;
		st_case_42:
		if ( ( (*( p))) == 98u ) {
			goto _st43;
		}
		{
			goto _st0;
		}
		_st43:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof43;
		st_case_43:
		if ( ( (*( p))) == 32u ) {
			goto _ctr89;
		}
		{
			goto _st0;
		}
		_st44:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof44;
		st_case_44:
		switch( ( (*( p))) ) {
			case 97u: {
				goto _st45;
			}
			case 117u: {
				goto _st47;
			}
		}
		{
			goto _st0;
		}
		_st45:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof45;
		st_case_45:
		if ( ( (*( p))) == 110u ) {
			goto _st46;
		}
		{
			goto _st0;
		}
		_st46:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof46;
		st_case_46:
		if ( ( (*( p))) == 32u ) {
			goto _ctr93;
		}
		{
			goto _st0;
		}
		_st47:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof47;
		st_case_47:
		switch( ( (*( p))) ) {
			case 108u: {
				goto _st48;
			}
			case 110u: {
				goto _st49;
			}
		}
		{
			goto _st0;
		}
		_st48:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof48;
		st_case_48:
		if ( ( (*( p))) == 32u ) {
			goto _ctr96;
		}
		{
			goto _st0;
		}
		_st49:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof49;
		st_case_49:
		if ( ( (*( p))) == 32u ) {
			goto _ctr97;
		}
		{
			goto _st0;
		}
		_st50:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof50;
		st_case_50:
		if ( ( (*( p))) == 97u ) {
			goto _st51;
		}
		{
			goto _st0;
		}
		_st51:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof51;
		st_case_51:
		switch( ( (*( p))) ) {
			case 114u: {
				goto _st52;
			}
			case 121u: {
				goto _st53;
			}
		}
		{
			goto _st0;
		}
		_st52:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof52;
		st_case_52:
		if ( ( (*( p))) == 32u ) {
			goto _ctr101;
		}
		{
			goto _st0;
		}
		_st53:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof53;
		st_case_53:
		if ( ( (*( p))) == 32u ) {
			goto _ctr102;
		}
		{
			goto _st0;
		}
		_st54:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof54;
		st_case_54:
		if ( ( (*( p))) == 111u ) {
			goto _st55;
		}
		{
			goto _st0;
		}
		_st55:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof55;
		st_case_55:
		if ( ( (*( p))) == 118u ) {
			goto _st56;
		}
		{
			goto _st0;
		}
		_st56:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof56;
		st_case_56:
		if ( ( (*( p))) == 32u ) {
			goto _ctr105;
		}
		{
			goto _st0;
		}
		_st57:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof57;
		st_case_57:
		if ( ( (*( p))) == 99u ) {
			goto _st58;
		}
		{
			goto _st0;
		}
		_st58:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof58;
		st_case_58:
		if ( ( (*( p))) == 116u ) {
			goto _st59;
		}
		{
			goto _st0;
		}
		_st59:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof59;
		st_case_59:
		if ( ( (*( p))) == 32u ) {
			goto _ctr108;
		}
		{
			goto _st0;
		}
		_st60:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof60;
		st_case_60:
		if ( ( (*( p))) == 101u ) {
			goto _st61;
		}
		{
			goto _st0;
		}
		_st61:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof61;
		st_case_61:
		if ( ( (*( p))) == 112u ) {
			goto _st62;
		}
		{
			goto _st0;
		}
		_st62:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof62;
		st_case_62:
		if ( ( (*( p))) == 32u ) {
			goto _ctr111;
		}
		{
			goto _st0;
		}
		_st63:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof63;
		st_case_63:
		if ( ( (*( p))) == 32u ) {
			goto _ctr9;
		}
		{
			goto _st0;
		}
		_st64:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof64;
		st_case_64:
		if ( ( (*( p))) == 114u ) {
			goto _st65;
		}
		{
			goto _st0;
		}
		_st65:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof65;
		st_case_65:
		if ( ( (*( p))) == 105u ) {
			goto _st66;
		}
		{
			goto _st0;
		}
		_st66:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof66;
		st_case_66:
		if ( ( (*( p))) == 44u ) {
			goto _st67;
		}
		{
			goto _st0;
		}
		_st67:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof67;
		st_case_67:
		if ( ( (*( p))) == 32u ) {
			goto _st67;
		}
		if ( 48u <= ( (*( p))) && ( (*( p))) <= 57u ) {
			goto _ctr2;
		}
		{
			goto _st0;
		}
		_st68:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof68;
		st_case_68:
		if ( ( (*( p))) == 111u ) {
			goto _st69;
		}
		{
			goto _st0;
		}
		_st69:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof69;
		st_case_69:
		if ( ( (*( p))) == 110u ) {
			goto _st66;
		}
		{
			goto _st0;
		}
		_st70:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof70;
		st_case_70:
		switch( ( (*( p))) ) {
			case 97u: {
				goto _st71;
			}
			case 117u: {
				goto _st69;
			}
		}
		{
			goto _st0;
		}
		_st71:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof71;
		st_case_71:
		if ( ( (*( p))) == 116u ) {
			goto _st66;
		}
		{
			goto _st0;
		}
		_st72:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof72;
		st_case_72:
		switch( ( (*( p))) ) {
			case 104u: {
				goto _st73;
			}
			case 117u: {
				goto _st74;
			}
		}
		{
			goto _st0;
		}
		_st73:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof73;
		st_case_73:
		if ( ( (*( p))) == 117u ) {
			goto _st66;
		}
		{
			goto _st0;
		}
		_st74:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof74;
		st_case_74:
		if ( ( (*( p))) == 101u ) {
			goto _st66;
		}
		{
			goto _st0;
		}
		_st75:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof75;
		st_case_75:
		if ( ( (*( p))) == 101u ) {
			goto _st76;
		}
		{
			goto _st0;
		}
		_st76:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof76;
		st_case_76:
		if ( ( (*( p))) == 100u ) {
			goto _st66;
		}
		{
			goto _st0;
		}
		_ctr121:
		{
#line 202 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			{{
#line 194 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 77; top+= 1; goto _st77;}}
		
#line 3361 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st77;
		_st77:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof77;
		st_case_77:
		switch( ( (*( p))) ) {
			case 40u: {
				goto _ctr121;
			}
			case 41u: {
				goto _ctr122;
			}
		}
		if ( ( (*( p))) > 91u ) {
			if ( 93u <= ( (*( p))) && ( (*( p))) <= 126u ) {
				goto _st77;
			}
		} else if ( ( (*( p))) >= 32u ) {
			goto _st77;
		}
		{
			goto _st0;
		}
		_ctr122:
		{
#line 203 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date.rl"
			{top -= 1;cs = stack[top];goto _again;} }
		
#line 3398 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
		
		goto _st97;
		_st97:
		if ( p == eof ) {
			if ( cs >= 78 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof97;
		st_case_97:
		{
			goto _st0;
		}
		st_out:
		_test_eof1: cs = 1; goto _test_eof; 
		_test_eof2: cs = 2; goto _test_eof; 
		_test_eof3: cs = 3; goto _test_eof; 
		_test_eof4: cs = 4; goto _test_eof; 
		_test_eof5: cs = 5; goto _test_eof; 
		_test_eof6: cs = 6; goto _test_eof; 
		_test_eof7: cs = 7; goto _test_eof; 
		_test_eof8: cs = 8; goto _test_eof; 
		_test_eof9: cs = 9; goto _test_eof; 
		_test_eof10: cs = 10; goto _test_eof; 
		_test_eof11: cs = 11; goto _test_eof; 
		_test_eof12: cs = 12; goto _test_eof; 
		_test_eof13: cs = 13; goto _test_eof; 
		_test_eof14: cs = 14; goto _test_eof; 
		_test_eof15: cs = 15; goto _test_eof; 
		_test_eof16: cs = 16; goto _test_eof; 
		_test_eof17: cs = 17; goto _test_eof; 
		_test_eof18: cs = 18; goto _test_eof; 
		_test_eof19: cs = 19; goto _test_eof; 
		_test_eof20: cs = 20; goto _test_eof; 
		_test_eof78: cs = 78; goto _test_eof; 
		_test_eof79: cs = 79; goto _test_eof; 
		_test_eof21: cs = 21; goto _test_eof; 
		_test_eof80: cs = 80; goto _test_eof; 
		_test_eof81: cs = 81; goto _test_eof; 
		_test_eof22: cs = 22; goto _test_eof; 
		_test_eof82: cs = 82; goto _test_eof; 
		_test_eof23: cs = 23; goto _test_eof; 
		_test_eof83: cs = 83; goto _test_eof; 
		_test_eof84: cs = 84; goto _test_eof; 
		_test_eof24: cs = 24; goto _test_eof; 
		_test_eof85: cs = 85; goto _test_eof; 
		_test_eof25: cs = 25; goto _test_eof; 
		_test_eof86: cs = 86; goto _test_eof; 
		_test_eof87: cs = 87; goto _test_eof; 
		_test_eof26: cs = 26; goto _test_eof; 
		_test_eof88: cs = 88; goto _test_eof; 
		_test_eof89: cs = 89; goto _test_eof; 
		_test_eof27: cs = 27; goto _test_eof; 
		_test_eof90: cs = 90; goto _test_eof; 
		_test_eof28: cs = 28; goto _test_eof; 
		_test_eof91: cs = 91; goto _test_eof; 
		_test_eof92: cs = 92; goto _test_eof; 
		_test_eof29: cs = 29; goto _test_eof; 
		_test_eof93: cs = 93; goto _test_eof; 
		_test_eof30: cs = 30; goto _test_eof; 
		_test_eof94: cs = 94; goto _test_eof; 
		_test_eof95: cs = 95; goto _test_eof; 
		_test_eof96: cs = 96; goto _test_eof; 
		_test_eof31: cs = 31; goto _test_eof; 
		_test_eof32: cs = 32; goto _test_eof; 
		_test_eof33: cs = 33; goto _test_eof; 
		_test_eof34: cs = 34; goto _test_eof; 
		_test_eof35: cs = 35; goto _test_eof; 
		_test_eof36: cs = 36; goto _test_eof; 
		_test_eof37: cs = 37; goto _test_eof; 
		_test_eof38: cs = 38; goto _test_eof; 
		_test_eof39: cs = 39; goto _test_eof; 
		_test_eof40: cs = 40; goto _test_eof; 
		_test_eof41: cs = 41; goto _test_eof; 
		_test_eof42: cs = 42; goto _test_eof; 
		_test_eof43: cs = 43; goto _test_eof; 
		_test_eof44: cs = 44; goto _test_eof; 
		_test_eof45: cs = 45; goto _test_eof; 
		_test_eof46: cs = 46; goto _test_eof; 
		_test_eof47: cs = 47; goto _test_eof; 
		_test_eof48: cs = 48; goto _test_eof; 
		_test_eof49: cs = 49; goto _test_eof; 
		_test_eof50: cs = 50; goto _test_eof; 
		_test_eof51: cs = 51; goto _test_eof; 
		_test_eof52: cs = 52; goto _test_eof; 
		_test_eof53: cs = 53; goto _test_eof; 
		_test_eof54: cs = 54; goto _test_eof; 
		_test_eof55: cs = 55; goto _test_eof; 
		_test_eof56: cs = 56; goto _test_eof; 
		_test_eof57: cs = 57; goto _test_eof; 
		_test_eof58: cs = 58; goto _test_eof; 
		_test_eof59: cs = 59; goto _test_eof; 
		_test_eof60: cs = 60; goto _test_eof; 
		_test_eof61: cs = 61; goto _test_eof; 
		_test_eof62: cs = 62; goto _test_eof; 
		_test_eof63: cs = 63; goto _test_eof; 
		_test_eof64: cs = 64; goto _test_eof; 
		_test_eof65: cs = 65; goto _test_eof; 
		_test_eof66: cs = 66; goto _test_eof; 
		_test_eof67: cs = 67; goto _test_eof; 
		_test_eof68: cs = 68; goto _test_eof; 
		_test_eof69: cs = 69; goto _test_eof; 
		_test_eof70: cs = 70; goto _test_eof; 
		_test_eof71: cs = 71; goto _test_eof; 
		_test_eof72: cs = 72; goto _test_eof; 
		_test_eof73: cs = 73; goto _test_eof; 
		_test_eof74: cs = 74; goto _test_eof; 
		_test_eof75: cs = 75; goto _test_eof; 
		_test_eof76: cs = 76; goto _test_eof; 
		_test_eof77: cs = 77; goto _test_eof; 
		_test_eof97: cs = 97; goto _test_eof; 
		
		_test_eof: {}
		if ( p == eof ) {
			switch ( cs ) {
				case 1: {
					break;
				}
				case 0: {
					break;
				}
				case 2: {
					break;
				}
				case 3: {
					break;
				}
				case 4: {
					break;
				}
				case 5: {
					break;
				}
				case 6: {
					break;
				}
				case 7: {
					break;
				}
				case 8: {
					break;
				}
				case 9: {
					break;
				}
				case 10: {
					break;
				}
				case 11: {
					break;
				}
				case 12: {
					break;
				}
				case 13: {
					break;
				}
				case 14: {
					break;
				}
				case 15: {
					break;
				}
				case 16: {
					break;
				}
				case 17: {
					break;
				}
				case 18: {
					break;
				}
				case 19: {
					break;
				}
				case 20: {
					break;
				}
				case 78: {
					break;
				}
				case 79: {
					break;
				}
				case 21: {
					break;
				}
				case 80: {
					break;
				}
				case 81: {
					break;
				}
				case 22: {
					break;
				}
				case 82: {
					break;
				}
				case 23: {
					break;
				}
				case 83: {
					break;
				}
				case 84: {
					break;
				}
				case 24: {
					break;
				}
				case 85: {
					break;
				}
				case 25: {
					break;
				}
				case 86: {
					break;
				}
				case 87: {
					break;
				}
				case 26: {
					break;
				}
				case 88: {
					break;
				}
				case 89: {
					break;
				}
				case 27: {
					break;
				}
				case 90: {
					break;
				}
				case 28: {
					break;
				}
				case 91: {
					break;
				}
				case 92: {
					break;
				}
				case 29: {
					break;
				}
				case 93: {
					break;
				}
				case 30: {
					break;
				}
				case 94: {
					break;
				}
				case 95: {
					break;
				}
				case 96: {
					break;
				}
				case 31: {
					break;
				}
				case 32: {
					break;
				}
				case 33: {
					break;
				}
				case 34: {
					break;
				}
				case 35: {
					break;
				}
				case 36: {
					break;
				}
				case 37: {
					break;
				}
				case 38: {
					break;
				}
				case 39: {
					break;
				}
				case 40: {
					break;
				}
				case 41: {
					break;
				}
				case 42: {
					break;
				}
				case 43: {
					break;
				}
				case 44: {
					break;
				}
				case 45: {
					break;
				}
				case 46: {
					break;
				}
				case 47: {
					break;
				}
				case 48: {
					break;
				}
				case 49: {
					break;
				}
				case 50: {
					break;
				}
				case 51: {
					break;
				}
				case 52: {
					break;
				}
				case 53: {
					break;
				}
				case 54: {
					break;
				}
				case 55: {
					break;
				}
				case 56: {
					break;
				}
				case 57: {
					break;
				}
				case 58: {
					break;
				}
				case 59: {
					break;
				}
				case 60: {
					break;
				}
				case 61: {
					break;
				}
				case 62: {
					break;
				}
				case 63: {
					break;
				}
				case 64: {
					break;
				}
				case 65: {
					break;
				}
				case 66: {
					break;
				}
				case 67: {
					break;
				}
				case 68: {
					break;
				}
				case 69: {
					break;
				}
				case 70: {
					break;
				}
				case 71: {
					break;
				}
				case 72: {
					break;
				}
				case 73: {
					break;
				}
				case 74: {
					break;
				}
				case 75: {
					break;
				}
				case 76: {
					break;
				}
				case 77: {
					break;
				}
				case 97: {
					break;
				}
			}
			switch ( cs ) {
			}
			switch ( cs ) {
				case 1:
				goto _st1;case 0:
				goto _st0;case 2:
				goto _st2;case 3:
				goto _st3;case 4:
				goto _st4;case 5:
				goto _st5;case 6:
				goto _st6;case 7:
				goto _st7;case 8:
				goto _st8;case 9:
				goto _st9;case 10:
				goto _st10;case 11:
				goto _st11;case 12:
				goto _st12;case 13:
				goto _st13;case 14:
				goto _st14;case 15:
				goto _st15;case 16:
				goto _st16;case 17:
				goto _st17;case 18:
				goto _st18;case 19:
				goto _st19;case 20:
				goto _st20;case 78:
				goto _ctr123;case 79:
				goto _st79;case 21:
				goto _st21;case 80:
				goto _ctr126;case 81:
				goto _ctr129;case 22:
				goto _st22;case 82:
				goto _ctr130;case 23:
				goto _st23;case 83:
				goto _ctr133;case 84:
				goto _ctr136;case 24:
				goto _st24;case 85:
				goto _ctr137;case 25:
				goto _st25;case 86:
				goto _ctr140;case 87:
				goto _ctr143;case 26:
				goto _st26;case 88:
				goto _ctr144;case 89:
				goto _ctr147;case 27:
				goto _st27;case 90:
				goto _ctr148;case 28:
				goto _st28;case 91:
				goto _ctr151;case 92:
				goto _ctr154;case 29:
				goto _st29;case 93:
				goto _ctr155;case 30:
				goto _st30;case 94:
				goto _ctr158;case 95:
				goto _ctr161;case 96:
				goto _ctr163;case 31:
				goto _st31;case 32:
				goto _st32;case 33:
				goto _st33;case 34:
				goto _st34;case 35:
				goto _st35;case 36:
				goto _st36;case 37:
				goto _st37;case 38:
				goto _st38;case 39:
				goto _st39;case 40:
				goto _st40;case 41:
				goto _st41;case 42:
				goto _st42;case 43:
				goto _st43;case 44:
				goto _st44;case 45:
				goto _st45;case 46:
				goto _st46;case 47:
				goto _st47;case 48:
				goto _st48;case 49:
				goto _st49;case 50:
				goto _st50;case 51:
				goto _st51;case 52:
				goto _st52;case 53:
				goto _st53;case 54:
				goto _st54;case 55:
				goto _st55;case 56:
				goto _st56;case 57:
				goto _st57;case 58:
				goto _st58;case 59:
				goto _st59;case 60:
				goto _st60;case 61:
				goto _st61;case 62:
				goto _st62;case 63:
				goto _st63;case 64:
				goto _st64;case 65:
				goto _st65;case 66:
				goto _st66;case 67:
				goto _st67;case 68:
				goto _st68;case 69:
				goto _st69;case 70:
				goto _st70;case 71:
				goto _st71;case 72:
				goto _st72;case 73:
				goto _st73;case 74:
				goto _st74;case 75:
				goto _st75;case 76:
				goto _st76;case 77:
				goto _st77;case 97:
				goto _st97;	}
		}
		
		if ( cs >= 78 )
			goto _out; _pop: {}
		_out: {}
	}
	
#line 34 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date_parser.rl"
	
	
	if (st_storage.data) {
		free (st_storage.data);
	}
	
	if ( cs < 
#line 3929 "/builddir/build/BUILD/rspamd-3.1/src/date_parser.rl.c"
	78
#line 40 "/builddir/build/BUILD/rspamd-3.1/src/ragel/smtp_date_parser.rl"
	) {
		g_set_error (err, g_quark_from_static_string ("smtp_date"), cs, "invalid date at offset %d (%c), state %d",
		(int)(p - data), (*p > 0 && *p < 128) ? *p : '?', cs);
		return (guint64)(-1);
	}
	
	return rspamd_tm_to_time (&tm, tz);
}